Newer
Older
# Copyright (c) 2010-2011, Diaspora Inc. This file is
# licensed under the Affero General Public License version 3 or later. See
# the COPYRIGHT file.
warning()
{
echo "WARNING: $1" >&2
}
fatal()
{
echo "FATAL: $1" >&2
exit 1
}
on_failure()
{
if [ $? != 0 ]
then
fi
}
# Check if already running/port blocked
chk_service()
{
port=${1:?Missing port}
case $os in
*[Bb][Ss][Dd]*|Darwin)
## checks ipv[46]
netstat -anL | awk '{print $2}' | grep "\.$1$"
;;
*)
# Is someone listening on the ports already? (ipv4 only test ?)
netstat -nl | grep '[^:]:'$port'[ \t]'
;;
esac
}
Sarah Mei
a validé
realpath=$( ruby -e "puts File.expand_path(\"$0\")")
cd $(dirname $realpath)/..
if [ -e "config/script_server.yml" ]
then
warning "config/script_server.yml was merged into config/diaspora.yml. Please read the changelog!"
if [ ! -e "config/database.yml" ]
then
fatal "config/database.yml is missing! Copy over config/database.yml.example to config/database.yml and edit it properly!"
if [ ! -e "config/diaspora.yml" ]
then
fatal "config/diaspora.yml is missing! Copy over config/diaspora.yml.example to config/diaspora.yml and edit it properly!"
RAILS_ENV=$(bundle exec ruby ./script/get_config.rb server.rails_environment)
os=$(uname -s)
vars=$(bundle exec ruby ./script/get_config.rb \
single_process_mode=environment.single_process_mode? \
embed_sidekiq_worker=server.embed_sidekiq_worker \
workers=server.sidekiq_workers
on_failure "Couldn't parse config/diaspora.yml!"
eval "$vars"
if [ -n "$DB" ]
for arg in $(echo $args | awk '{ for (i = 1; i <= NF; i++) print $i}')
[ "$prev_arg" = '-p' ] && port="$arg"
prev_arg="$arg"
services=$(chk_service $port )
if [ -n "$services" ]
then
fatal "Port $port is already in use.\n\t$services"
if [ -w "public" -a ! -e "public/source.tar.gz" ]
then
if command -v git > /dev/null 2>&1 && git rev-parse --is-inside-work-tree > /dev/null 2>&1
then
branch=$(git branch | awk '/^[*]/ {print $2}')
tar czf public/source.tar.gz $(git ls-tree -r $branch | awk '{print $4}')
else
fatal "Can't generate public/source.tar.gz for you.
Please tar up a copy of your Diaspora installation and place it there."
fatal "Can't find public/source.tar.gz"
# Check if assets are precompiled
if [ "$RAILS_ENV" = "production" -a -z "$(find public/assets -maxdepth 1 -name 'default-*.css' -print -quit)" ]
fatal "You're running in production mode without having assets
precompiled. Now and after each update before you restart the
application, run:
bundle exec rake assets:precompile"
# Check for old curl versions (see https://github.com/diaspora/diaspora/issues/4202)
if [ `curl -V | grep AsynchDNS | wc -l` -ne 1 ]
then
warning "
*****************************************************************
curl does not support async DNS, this can cause Sidekiq to crash!
Please update curl to version 7.32, see issue
https://github.com/diaspora/diaspora/issues/4202 for details
*****************************************************************
"
fi
echo -n "Starting Diaspora in $RAILS_ENV mode on port $port "
if [ "$embed_sidekiq_worker" = "true" ]
then
echo "with a Sidekiq worker embedded into Unicorn."
workers=0
elif [ "$single_process_mode" = "true" ]
then
echo "with job processing inside the request cycle."
workers=0
else
echo "with $workers Sidekiq worker(s)."
MrZYX
a validé
exec bundle exec foreman start -m "xmpp=$vines,web=1,sidekiq=$workers" -p $port